/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gps.com.Jpa;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author Oussama
 */
@Entity
@Table(name = "meeting")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Meeting.findAll", query = "SELECT m FROM Meeting m"),
    @NamedQuery(name = "Meeting.findByIdMeeting", query = "SELECT m FROM Meeting m WHERE m.idMeeting = :idMeeting"),
    @NamedQuery(name = "Meeting.findByNameMeeting", query = "SELECT m FROM Meeting m WHERE m.nameMeeting = :nameMeeting"),
    @NamedQuery(name = "Meeting.findByXCoord", query = "SELECT m FROM Meeting m WHERE m.xCoord = :xCoord"),
    @NamedQuery(name = "Meeting.findByYCoord", query = "SELECT m FROM Meeting m WHERE m.yCoord = :yCoord")})
public class Meeting implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "ID_MEETING")
    private Integer idMeeting;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 45)
    @Column(name = "NAME_MEETING")
    private String nameMeeting;
    @Size(max = 45)
    @Column(name = "X_COORD")
    private String xCoord;
    @Size(max = 45)
    @Column(name = "Y_COORD")
    private String yCoord;
    @JoinTable(name = "user_meeting", joinColumns = {
        @JoinColumn(name = "ID_MEETING", referencedColumnName = "ID_MEETING")}, inverseJoinColumns = {
        @JoinColumn(name = "ID_USER", referencedColumnName = "ID_USER")})
    @ManyToMany
    private List<User> userList;
    @JoinColumn(name = "ID_USER_ADMIN", referencedColumnName = "ID_USER")
    @ManyToOne(optional = false)
    private User idUserAdmin;
        @Basic(optional = false)
    @NotNull
    @Column(name = "DATE_MEETING")
    @Temporal(TemporalType.TIMESTAMP)
    private Date dateMeeting;

    public Meeting() {
    }

    public Meeting(Integer idMeeting) {
        this.idMeeting = idMeeting;
    }

    public Meeting(Integer idMeeting, String nameMeeting) {
        this.idMeeting = idMeeting;
        this.nameMeeting = nameMeeting;
    }

     public Meeting(Integer idMeeting,User idUserAdmin,String nameMeeting,String xCoord,String yCoord,Date dateMeeting) {
        this.idMeeting = idMeeting;
        this.idUserAdmin = idUserAdmin;
        this.nameMeeting = nameMeeting;
        this.xCoord = xCoord;
        this.yCoord = yCoord;
        this.dateMeeting = dateMeeting;
    }
    
    public Date getDateMeeting() {
        return dateMeeting;
    }

    public void setDateMeeting(Date date) {
        this.dateMeeting = date;
    }
     
    public Integer getIdMeeting() {
        return idMeeting;
    }

    public void setIdMeeting(Integer idMeeting) {
        this.idMeeting = idMeeting;
    }

    public String getNameMeeting() {
        return nameMeeting;
    }

    public void setNameMeeting(String nameMeeting) {
        this.nameMeeting = nameMeeting;
    }

    public String getXCoord() {
        return xCoord;
    }

    public void setXCoord(String xCoord) {
        this.xCoord = xCoord;
    }

    public String getYCoord() {
        return yCoord;
    }

    public void setYCoord(String yCoord) {
        this.yCoord = yCoord;
    }

    @XmlTransient
    public List<User> getUserList() {
        return userList;
    }

    public void setUserList(List<User> userList) {
        this.userList = userList;
    }

    public User getIdUserAdmin() {
        return idUserAdmin;
    }

    public void setIdUserAdmin(User idUserAdmin) {
        this.idUserAdmin = idUserAdmin;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idMeeting != null ? idMeeting.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Meeting)) {
            return false;
        }
        Meeting other = (Meeting) object;
        if ((this.idMeeting == null && other.idMeeting != null) || (this.idMeeting != null && !this.idMeeting.equals(other.idMeeting))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gps.com.Jpa.Meeting[ idMeeting=" + idMeeting + " ]";
    }
    
}
