/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gps.com.webService;

import gps.com.Jpa.Coordonnees;
import gps.com.Jpa.Invitation;
import gps.com.Jpa.Meeting;
import gps.com.Jpa.Messagerie;
import gps.com.Jpa.User;
import gps.com.dao.MeetingDao;
import gps.com.dao.SendMail;
import gps.com.dao.UserDao;
import gps.com.daoImpl.CoordonneeDaoImpl;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;

/**
 *
 * @author oussama
 */
    /*  
    * @WebMethod : 
    * public String[] createUser(String name,String prenom,String phone,String email,String password);
    * public void removeUser(String mail,String code);
    * public void editUser(String mail,String nom,String prenom,String password,String phone,String code);
    * public List<User> getAllUser();
    * public List<User> findUser(String rechercher);
    * public String activer(String mail,String code,String android_code);    
    * public String inviter(String nomMeeting,String mail1,String mail2,String code);
    * public String ajouter_ami_sansgroupe(String mail1,String mail2,String code);
    * public void SupprimerAmi(String mail1,String mail2);
    * public String createRendezvous(String email_admin,String nom,String coord_x,String coord_y,String code);
    * public int connection(String mail,String password,String code);
    * public void deconnecter(String mail,String code);
    
* Autres :
    * public static String message_erreur(int i);
    * public static boolean checkEmail(String email);
    */




@WebService(serviceName = "GpsWebService")
@Stateless()
public class GpsWebService {
    private static final float distMax = 500;
    private static final float refreshCentroid = 2;
    
    @EJB
    private UserDao userDao;
    
    @EJB
    private MeetingDao meetingDao;     
    
    private Meeting rendezvous;
    /**
     *
     * @param name
     * @param prenom
     * @param phone
     * @param email
     * @param password
     * @param secretCode
     * @return
     */
    @WebMethod
    public User createUser(@WebParam(name="name") String name,
                           @WebParam(name="prenom") String prenom,
                           @WebParam(name="phone") String phone,
                           @WebParam(name="email") String email,
                           @WebParam(name="password") String password,
                           @WebParam(name="secretCode") String secretCode) {
            
        User userResult = new User();
        boolean bool = true;       
        boolean boolCode = verifySecretCode(secretCode);
        
        if(boolCode) {
            //vérification existence user par mail + phone
            if(userDao.findUserByMail(email).isEmpty()) userResult.setEmail("false");
            if(userDao.findUserByPhone(phone).isEmpty()) userResult.setPhone("false");

            if(userResult.getEmail().equalsIgnoreCase("false") && userResult.getPhone().equalsIgnoreCase("false")) {
                if (!checkEmail(email)) {
                    userResult.setEmail("invalid");
                    bool = false;
                } 
                
                if (password == null || password.length() < 5) {
                    userResult.setPassword("false");
                    bool = false;
                }
                
                if (name == null) {
                    userResult.setNom("false");
                    bool = false;
                }

              if (bool) 
                {
                    //String generatedCode = Long.toHexString(Double.doubleToLongBits(Math.random()));
                    String generatedCode = generate_entier(4);
                    //String generatedCode = "0000";
                    userResult.setGeneratedCode(generatedCode);
                    
                    
                    User U = new User(1,phone,email,generatedCode,secretCode,password,name,prenom,(short) 0,(short) 0,1);
                                       
                    
                    userDao.create(U);            

                    //Envoie de mail
                   SendMail.envoyer("Pour activer votre compte inserer votre code d'activation : "+generatedCode+" .... ",email,"Code Activation");
                     
                   
                   
                    //Création réussie. 
                    userResult.setActivate((short) 1);
                }
            }
              
        } else {
            userResult.setSecretCode("invalide");
        }
        
        return userResult;                
    }
    /*
    @WebMethod
    public List<Meeting> getMeetingById(@WebParam(name="idMeeting") String id,
                                @WebParam(name="email") String email,
                                @WebParam(name="secretCode") String secretCode) {        
      
        if(!userDao.findUserByMail(email).isEmpty()) {
            User u = userDao.findUserByMail(email).get(0);
            if(u.getSecretCode().equals(secretCode)) {               
               return meetingDao.findMeetingById(id);
            }            
        }
        
        return null;         
    }*/
    
      @WebMethod
    public String setVisibilityMeeting(@WebParam(name="email") String email,
                                @WebParam(name="secretCode") String secretCode,
                                @WebParam(name="idMeeting") String id_m) {        
      
        String msg="false";
        if(!userDao.findUserByMail(email).isEmpty()) {
            User u = userDao.findUserByMail(email).get(0);
            if(u.getSecretCode().equals(secretCode)) 
            {   
                  if(!userDao.trouver_rdv_par_id(Integer.parseInt(id_m)).isEmpty()) 
                  { 
                       List<Meeting> liste= findMeeting(email,secretCode);
                       for(int i=0;i<liste.size();i++)
                       {
                          
                           Meeting m =liste.get(i);
                           if(m.getIdMeeting()==Integer.parseInt(id_m))
                           {   
                                 u.setVisibilityMeeting(Integer.parseInt(id_m));
                                 userDao.edit(u);
                                 msg="true";
                                 break;
                           }
                       
                       }
                      
                  }
            }         
        }
        return msg;         
    }
    
    @WebMethod
    public List<Coordonnees> getUsersInMeeting(
                                @WebParam(name="email") String email,
                                @WebParam(name="secretCode") String secretCode){
        
        List<Coordonnees> listCo = new ArrayList<>();
        
        if(!userDao.findUserByMail(email).isEmpty()) { 
           User u = userDao.findUserByMail(email).get(0);
           if(u.getSecretCode().equalsIgnoreCase(secretCode)) {
             
               listCo=userDao.coordonnees_membre_rdv(u);
               
               if(!userDao.trouver_rdv_par_id(u.getVisibilityMeeting()).isEmpty()) { 
                    Meeting m=userDao.trouver_rdv_par_id(u.getVisibilityMeeting()).get(0);
                    //Meeting m=userDao.findMeetingByid(u.getVisibilityMeeting()).get(0);
                    //verifier si l'utilisateur est le createur du meeting 
                    if(m.getIdUserAdmin().getIdUser()==u.getIdUser())
                    {// on fait la mise a jour du point central
                         updateCentroidMeeting(u,  m, listCo); 
                    }
               }
           }
        }
        return listCo;
    }
    
    @WebMethod
    public void removeUser(@WebParam(name="email") String email,
                           @WebParam(name="secretCode") String secretCode){
        if(!userDao.findUserByMail(email).isEmpty()) {
            User u = userDao.findUserByMail(email).get(0);
            if(u.getSecretCode().equals(secretCode)) {
                userDao.remove(u);
            } 
        }               
    }
    
    //==========================================================================
    // Fonction de login 
    //==========================================================================
    @WebMethod
    public boolean isUserExists(@WebParam(name="email") String email,
                             @WebParam(name="password") String password,
                             @WebParam(name="secretCode") String secretCode)
    {   
        if(!userDao.findUserByMail(email).isEmpty()) {
               
            User u = userDao.findUserByMail(email).get(0);

            //ATTENTION : on verifit si le code est legal ou pas, on ne compare pas avec celui qui est stocke dans la BDD
            if(verifySecretCode(secretCode) && u.getPassword().equals(password) )
            {   
                //MAJ le code secret dans la BDD
                /*
                //x1. avant la mise a jour du code secret, verifier bien si ce code est unique dans la BDD
                if(!userDao.findUserBySecretCode(secretCode).isEmpty())
                {
                      User u_2 = userDao.findUserBySecretCode(secretCode).get(0);
                      u_2.setSecretCode("code_obsolete123456");
                      userDao.edit(u_2);
                }*/
               
                //x.2 mettre a jour le code secret dans la BDD
                u.setSecretCode(secretCode);                
                userDao.edit(u);
               
                return true;
            }
        }     
        return false;               
    }

    
    
    /**
     *
     * @return
     */
    @WebMethod 
    public String DeleteFriend (@WebParam(name="email") String email,
                              @WebParam(name="secretCode") String secretCode,
                              @WebParam(name="listFriend") String liste)            
    {       
       
        if(!userDao.findUserByMail(email).isEmpty()) {
               
            User u = userDao.findUserByMail(email).get(0);
 
            if(u.getSecretCode().equalsIgnoreCase(secretCode))
            {   
              // tout est ok  
                userDao.supprimer_amis(u,liste);
  
                return "true";
            }
 
        } 
        return "false";
            
    } 
        
    
     /**
     *
     * @return
     */
    @WebMethod 
    public String getPointMeeting (@WebParam(name="email") String email,
                              @WebParam(name="secretCode") String secretCode)
                                       
    {       
       
        if(!userDao.findUserByMail(email).isEmpty()) {
               
            User u = userDao.findUserByMail(email).get(0);
 
            if(u.getSecretCode().equalsIgnoreCase(secretCode))
            {   
              // tout est ok 
                Coordonnees pt_m=userDao.trouver_point_meeting(u);
                String resultat=pt_m.getXCoord()+";"+pt_m.getYCoord();
                if(!userDao.trouver_rdv_par_id(u.getVisibilityMeeting()).isEmpty()) { 
                    Meeting m=userDao.trouver_rdv_par_id(u.getVisibilityMeeting()).get(0);
                    resultat += ";"+ m.getNameMeeting();
                }
                else 
                    resultat += ";[nom metting]";
                return resultat;
            }
 
        } 
        return "false";
            
    } 


    /**
     *
     * @return
     */
    @WebMethod 
    public List<User> getAllUser(){            
       return userDao.findAll(); 
    } 
    
    @WebMethod 
    public List<User> findUserByEverything(@WebParam(name="parameter") String parameter){ 
        return userDao.findUser(parameter); 
    } 
    
    @WebMethod
    public List<User> findUserByEmail( @WebParam(name="email") String email,
                                       @WebParam(name="secretCode") String secretCode ) {
 
      if(!userDao.findUserByMail(email).isEmpty()) {
             User u = userDao.findUserByMail(email).get(0); 
             if(u.getSecretCode().equals(secretCode)) {
                 return  userDao.findUserByMail(email);
             } 
        }              
        return null;           
    }
    
    
    @WebMethod
    public String activateAccount(@WebParam(name="email") String email,
                                  @WebParam(name="secretCode") String secretCode,
                                  @WebParam(name="generatedCode") String generatedCode) {
  
        String result = "false";
        if(!userDao.findUserByMail(email).isEmpty()) {
            User u = userDao.findUserByMail(email).get(0);

            if(u.getEmail().equals(email) && u.getSecretCode().equals(secretCode) && u.getGeneratedCode().equals(generatedCode))
            {
               u.setActivate((short)1);
               userDao.edit(u);
               result = "true";
               SendMail.envoyer("Votre compte est activé",u.getEmail(),"Activation de votre compte");
            }                   
        }
        
        return result;
    }

    //Pour ajouter des amis mettre Amis+user.getEmail() dans le nomMeeting
    //ajouter un ami a un groupe 
   
        /**
     *
     * @param meetingName
     * @param email1
     * @param email2
     * @param secretCode
     * @return
     */
        @WebMethod
    public String inviteMeetingFriend(@WebParam(name="meetingName") String meetingName,
                                @WebParam(name="email1") String mail1,
                                @WebParam(name="email2") String mail2,
                                @WebParam(name="secretCode") String secretCode){
        String msg = "false";

        if(userDao.findMeetingByName(meetingName).isEmpty())
        {
            return "le nom de meeting n'existe pas.";
        }
        
        Meeting m1= userDao.findMeetingByName(meetingName).get(0);
        
        if(!userDao.findUserByMail(mail1).isEmpty()) 
        {     
           User user1 = userDao.findUserByMail(mail1).get(0);
           if(user1.getSecretCode().equals(secretCode)) 
           {
                if(mail2 == null)
                {
                    msg ="Email du destinataire invalide";
                }
                else 
                {
                   if(checkEmail(mail2)) 
                   {
                      Messagerie m =null;

                      if(!userDao.findUserByMail(mail2).isEmpty()) 
                      {
                          //utilisateur existe.
                           
                            msg="true";

                            User u2 = userDao.findUserByMail(mail2).get(0);                    

                             userDao.Ajouter_ami_dans_meeting(m1, user1, u2);
                      }                                 
                      else
                      { 
                            msg ="Email du destinataire n'existe pas";
                      }
                 
                 } 
                   else msg = "Email du destinataire invalide";
                }
             } 
             else 
               msg ="erreur: code secret inconnu..";
        }
        return msg;
    }
   
     /**
     * @param meetingName*
     * @param email1*
     * @param email2
     * @param secretCode* *****************************/
    
    
    @WebMethod
    public void deleteFriendfromgroupe(@WebParam(name="meetingName") String meetingName,
                                @WebParam(name="email1") String email1,
                                @WebParam(name="email2") String email2,
                                @WebParam(name="secretCode") String secretCode){
        
        if(!userDao.findUserByMail(email1).isEmpty())
        { 
            User user1 = userDao.findUserByMail(email1).get(0);
            if(user1.getSecretCode().equals(secretCode)) {             
                if(checkEmail(email2))
                {
                   if(!userDao.findUserByMail(email2).isEmpty()) {
                       User user2 = userDao.findUserByMail(email2).get(0);
                        if(!userDao.findMeetingByName(meetingName).isEmpty()) 
                        {
        Meeting m = userDao.findMeetingByName(meetingName).get(0);   
        Invitation i = userDao.findInvitationByUsersMeeting(user1.getIdUser(),user2.getIdUser(),m.getIdMeeting()).get(0);
                        userDao.deleteinvitation(i);
                        } 
                    }
             }
        }
        
    
      }
        
           
    }
    
    
    /*
    public String addFriend(@WebParam(name="email1") String mail1,
                          @WebParam(name="email2") String mail2,
                          @WebParam(name="secretCode") String code) {
        if(!userDao.findUserByMail(mail1).isEmpty()) { 
            
            return null;
        } else {
            return "email1 invalide";
        }
    }
    */
    //ajouter un ami
    
    
public String generate(int length)
{
	    String chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890"; // Tu supprimes les lettres dont tu ne veux pas
	    String pass = "";
	    for(int x=0;x<length;x++)
	    {
	       int i = (int)Math.floor(Math.random() * 62); // Si tu supprimes des lettres tu diminues ce nb
	       pass += chars.charAt(i);
	    }
	    System.out.println(pass);
	    return pass;
}    
    
public String generate_entier(int length)
{
	    String chars = "1234567890"; // Tu supprimes les lettres dont tu ne veux pas
	    String pass = "";
	    for(int x=0;x<length;x++)
	    {
	       int i = (int)Math.floor(Math.random() * 10); // Si tu supprimes des lettres tu diminues ce nb
	       pass += chars.charAt(i);
	    }
	    System.out.println(pass);
	    return pass;
}    
    
    @WebMethod
    public String addFriend(@WebParam(name="email1") String mail1,
                            @WebParam(name="email2") String mail2,
                            @WebParam(name="nom") String nom,
                            @WebParam(name="prenom") String prenom,
                            @WebParam(name="secretCode") String code){
        String msg = "false";

        if(!userDao.findUserByMail(mail1).isEmpty()) 
        {     
           User user1 = userDao.findUserByMail(mail1).get(0);
           if(user1.getSecretCode().equals(code)) 
           {
                if(mail2 == null )
                {
                    msg ="Email du destinataire invalide";
                }
                else 
                {
                   if(checkEmail(mail2)) 
                   {
                      Messagerie m =null;

                      if (userDao.findUserByMail(mail2).isEmpty()==false) 
                      {
                               m = new Messagerie(1,user1.getEmail(),mail2,user1.getNom()+" " + user1.getPrenom()+" vous as envoyer une invitation, connectez vous sur le logiciel GPSCommunautaire");
                                
                      }                                 
                      else
                      {
                           
                      String password = generate(8);   
                          
                      
                      
                      createUser(nom,
                                     prenom,
                                           "0000000000",
                                           mail2,
                                           password,
                                           code)                                                ;
                       
                       m = new Messagerie(1,user1.getEmail(),mail2,user1.getNom()+" " + user1.getPrenom()+" vous a envoyer une invitation: \n Telecharger l'application sur http:\\xxxxxxxx \n login : "+mail2+" \n Password : "+password+"\n");
                      }
                    //  if (true)
                   //   return "juste avant l'envoi du mail";
                      
                      SendMail.envoyer(m.getMessage(), mail2,"Invitation");
                      
                     /* 
                      Meeting meeting = meetingDao.find(1);
                      if(!userDao.findUserByMail(mail2).isEmpty()) 
                      {//si existe
                        User user2 = userDao.findUserByMail(mail2).get(0);
                        Date aujourdhui = new Date();
                        SimpleDateFormat formater = new SimpleDateFormat("dd/MM/yyyy hh:mm:ss");
                        String jour = formater.format(aujourdhui).toString();
                        Invitation invitation = new Invitation(1,jour,0,meeting,user1,user2);
                        userDao.createInvitation(invitation);
                        SendMail.envoyer(user1.getEmail()+" " + user1.getPrenom()+" vous a envoyer une invitation"
                                                              + " pour accepter cliquer ici:...",mail2,"Invitation");
                        userDao.stocker_msg(m);
                    } else {
                        SendMail.envoyer(user1.getEmail()+" " + user1.getPrenom()+" vous as envoyer une invitation, veuillez telecharger l'application ici : ...",mail2,"Invitation");
                    }
                      */
                    msg="true";
                   
// User u1 = userDao.findUserByMail(email).get(0);
User u2 = userDao.findUserByMail(mail2).get(0);                    
                    
/*
  List<User> userlist = new ArrayList<>();
  
                    userlist.add(user1);
                    u2.setUserList(userlist);
                        
                    List<User> userlist1 = new ArrayList<>();
                    userlist1.add(u2);
                    user1.setUserList(userlist1);


                     userDao.addFriend(user1, u2);
  */                   
                     userDao.Ajouter_ami(user1, u2);
                    
                    
                 } 
                   else msg = "Email du destinataire invalide";
                }
             } 
             else 
               msg ="erreur: code secret inconnu..";
        }
        return msg;
    }
    
    
    //Les demandes d'ajouts
       /**
     *
     * @param email
     * @param code
     * @return
     */
        @WebMethod  
    public List<User> demande_ajout(@WebParam(name="email") String email,
                                    @WebParam(name="secretCode") String code){
        List<User> listuser = new ArrayList<>();
                      
        if(!userDao.findUserByMail(email).isEmpty())
        { 
           User u = userDao.findUserByMail(email).get(0);
           if(u.getSecretCode().equals(code)) {
              listuser = userDao.findUserByInvitation(u.getIdUser());
            }
        } 
        return listuser;
    }
    
    //Accepter une demande
     /**
     *
     * @param email
     * @param emailInvite
     * @param code
     */
        @WebMethod
    public void accepter_demande(@WebParam(name="email") String email,
                                 @WebParam(name="emailInvite") String emailInvite,
                                 @WebParam(name="secretCode") String code){
      if(!userDao.findUserByMail(email).isEmpty())
        { 
           User u1 = userDao.findUserByMail(email).get(0);
           
           if(u1.getSecretCode().equals(code)) {
                if(emailInvite != null) {
                    
                   if(!userDao.findUserByMail(emailInvite).isEmpty()) {
                    User u2 = userDao.findUserByMail(emailInvite).get(0);          
                    Invitation i = userDao.findInvitationByUsers(u2.getIdUser(),u1.getIdUser()).get(0);
                    i.setAmi(1);
                    
                    List<User> userlist = new ArrayList<>();
                    userlist.add(u1);
                    u2.setUserList(userlist);
                        
                    List<User> userlist1 = new ArrayList<>();
                    userlist1.add(u2);
                    u1.setUserList(userlist1);
                    
                    userDao.addFriend(u1, u2);
                    userDao.updateInvitation(i);
                    }    
                } 
            }
        } 
    }
      //Tous mes amis
    @WebMethod
    public List<User> findUserFriendsByEmail(@WebParam(name="email") String email,
                                             @WebParam(name="secretCode") String code){
       
        
        List<User> listuser = new ArrayList<>();
        if(!userDao.findUserByMail(email).isEmpty()) { 
           User u = userDao.findUserByMail(email).get(0);
           if(u.getSecretCode().equals(code)) {
               
                /*listuser = u.getUserList();          
                listuser.addAll(u.getUserList1());
                Set set = new HashSet() ;
                set.addAll(listuser) ;
                List<User> distinctUser = new ArrayList(set) ;
                return distinctUser;
                */
               
                return userDao.Liste_de_tous_les_amis(u);
                
           }
        } 
        return null;
    }
     //Tous mes amis
    @WebMethod
    public List<User> getUserFriendsByEmail(@WebParam(name="email") String email,
                                             @WebParam(name="secretCode") String code){
        
        List<User> listuser = new ArrayList<>();
        if(!userDao.findUserByMail(email).isEmpty()) { 
           User u = userDao.findUserByMail(email).get(0);
           if(u.getSecretCode().equals(code)) {
                listuser = u.getUserList();
            }
        } 
        return listuser;
    }
    
    
    
 /*--------------------------------------------------------------------*/
    /*----------------------------------------------------------------*/
    
     
   /**
     *
     * @param email_admin
     * @param nom
     * @param coord_x
     * @param coord_y
     * @param code
     * @return
     */
    
    
     
      @WebMethod
    public String createRendezvous(@WebParam(name="email") String email_admin,
                                   @WebParam(name="nom") String nom,
                                   @WebParam(name="coord_x") String coord_x,
                                   @WebParam(name="coord_y") String coord_y,
                                   @WebParam(name="secretCode") String code) {
       
        int erreur = 0;
   
        if(!userDao.findUserByMail(email_admin).isEmpty()) {
            if ( nom == null) erreur = 1;
            if ( coord_x == null ) erreur = 2;
            if ( coord_y == null ) erreur = 2;

            if(userDao.findMeetingByName(nom).isEmpty())
            {        
                if(erreur == 0)
                { 
                User u = userDao.findUserByMail(email_admin).get(0);

                if(u.getSecretCode().equals(code))
                {
                    Date time = new Date();
                    Meeting meet = new Meeting(1,u,nom,coord_x, coord_y,time);
                    List<User> userlist = new ArrayList<>();
                    userlist.add(u);
                    meet.setUserList(userlist);
                    userDao.createMeeting(u, meet);
                }
                else erreur = 4; 

                }
                }
                else erreur = 3;
        } else {
            erreur = 4;
        }
        
        return message_erreur(erreur);
         
    }
    
     /*------demande ajout groupe**************/

    /**
     *
     * @param email
     * @param code
     * @return
     */
    
    
         @WebMethod  
    public List<Invitation> demandeajoutGroupe(@WebParam(name="email") String email,
                                    @WebParam(name="secretCode") String code){
      
        if(!userDao.findUserByMail(email).isEmpty())
        { 
           User u = userDao.findUserByMail(email).get(0);
           if(u.getSecretCode().equals(code)) {
              return userDao.findAllFriendGroupNotaccepted(u.getIdUser());
            }
        } 
        return null;
    }

    /**
     *
     * @param email
     * @param meetingName
     * @param secretCode
     */
    @WebMethod  
    public void accepterajoutGroupe(@WebParam(name="email") String email,
                                    @WebParam(name="meetingName") String meetingName,
                                    @WebParam(name="secretCode") String secretCode){
      
        if(!userDao.findUserByMail(email).isEmpty())
        { 
           User u = userDao.findUserByMail(email).get(0);
           if(u.getSecretCode().equals(secretCode)) {
            if(!userDao.findMeetingByName(meetingName).isEmpty()) 
              {
                  System.out.println("test");
            Meeting m = userDao.findMeetingByName(meetingName).get(0);   
            Invitation i = userDao.findInvitationByUser_Meeting(u.getIdUser(),m.getIdMeeting()).get(0);
            i.setAmi(1);
            userDao.updateInvitation(i);
              }
           }
        } 
    }

    /**
     *
     * @param email
     * @param meetingName
     * @param secretCode
     * @return
     */
    @WebMethod  
    public User getAdmingroupe(@WebParam(name="email") String email,
                                    @WebParam(name="meetingName") String meetingName,
                                    @WebParam(name="secretCode") String secretCode){
      
        System.out.println(email+" "+meetingName+" "+secretCode);
        if(!userDao.findUserByMail(email).isEmpty())
        { 
           User u = userDao.findUserByMail(email).get(0);
           if(u.getSecretCode().equals(secretCode)) {
            if(!userDao.findMeetingByName(meetingName).isEmpty()) 
              {
            Meeting m = userDao.findMeetingByName(meetingName).get(0);   
            return m.getIdUserAdmin();
              }
           }
        } 
        
        return null;
    }
    
/*************************** CREATE MEETING NEW
     * @param email
     * @param nom
     * @param secretCode
     *******************************/
    @WebMethod
    public void createMeeting(@WebParam(name="email") String email,
                                   @WebParam(name="nom") String nom,
                                   @WebParam(name="secretCode") String secretCode) {
       
        int erreur = 0;
   
        if(!userDao.findUserByMail(email).isEmpty()) {
            if ( nom == null) erreur = 1;
   
            if(userDao.findMeetingByName(nom).isEmpty())
            {        
                if(erreur == 0)
                { 
                User u = userDao.findUserByMail(email).get(0);

                if(u.getSecretCode().equals(secretCode))
                {
                    Coordonnees c = dernierecoordonnees_user(email, secretCode);
                    Date time = new Date();
                    Meeting meet = new Meeting(1,u,nom,c.getXCoord(),c.getYCoord(),time);
                    List<User> userlist = new ArrayList<>();
                    userlist.add(u);
                    meet.setUserList(userlist);
                    userDao.createMeeting(u, meet);
                }
                
                }
              }
        }          
    }
 
/***********EDIT MEETING
     * @param email
     * @param nomgroupe
     * @param secretCode
     * @param nouveaunom
     ******************/

    @WebMethod
    public void editMeeting(@WebParam(name="email") String email,
                                   @WebParam(name="nomgroupe") String nomgroupe,
                                   @WebParam(name="nouveaunom") String nouveaunom,
                                   @WebParam(name="secretCode") String secretCode) {
       
        int erreur = 0;
        System.out.println("ici"+email+nomgroupe+nouveaunom+secretCode);
        if(!userDao.findUserByMail(email).isEmpty()) {
            if ( nouveaunom == null) erreur = 1;
   
            if(!userDao.findMeetingByName(nomgroupe).isEmpty())
            {        
                if(erreur == 0)
                { 
                    User u = userDao.findUserByMail(email).get(0);
                    
                if(u.getSecretCode().equals(secretCode))
                {
                    Meeting m = userDao.findMeetingByName(nomgroupe).get(0);
                    Coordonnees c = dernierecoordonnees_user(email, secretCode);
                    Date time = new Date();
                    if((m.getIdUserAdmin().getIdUser()).equals(u.getIdUser()) && userDao.findMeetingByName(nouveaunom).isEmpty())
                    { 
                    m.setXCoord(c.getXCoord());
                    m.setYCoord(c.getYCoord());
                    m.setDateMeeting(time);
                    m.setNameMeeting(nouveaunom);
                    userDao.updateMeeting(m);
                    }
                }
                
                }
              }
        }          
    }
 /***************MAKE VISIBLE GROUPE
  * 
     * @param email
     * @param meetingName
     * @param secretCode
  */
    @WebMethod  
    public void makeVisibleInGroupe(@WebParam(name="email") String email,
                                    @WebParam(name="meetingName") String meetingName,
                                    @WebParam(name="secretCode") String secretCode){
      
        if(!userDao.findUserByMail(email).isEmpty())
        { 
           User u = userDao.findUserByMail(email).get(0);
           if(u.getSecretCode().equals(secretCode)) {
            if(!userDao.findMeetingByName(meetingName).isEmpty()) 
              {
            Meeting m = userDao.findMeetingByName(meetingName).get(0);   
            u.setVisibilityMeeting(m.getIdMeeting());
            userDao.edit(u);
              }
           }
        } 
    }
/******IS VISIBLE
     * @param email
     * @param meetingName
     * @param secretCode
     * @return  */
    @WebMethod  
    public boolean isVisibleInGroupe(@WebParam(name="email") String email,
                                    @WebParam(name="meetingName") String meetingName,
                                    @WebParam(name="secretCode") String secretCode){
        System.out.println("eee"+email+" "+meetingName+" "+secretCode);
        System.out.println("iiiiiiiiiiiin");
        
        if(!userDao.findUserByMail(email).isEmpty())
        { 
           User u = userDao.findUserByMail(email).get(0);
           if(u.getSecretCode().equals(secretCode)) {
            if(!userDao.findMeetingByName(meetingName).isEmpty()) 
              {
            Meeting m = userDao.findMeetingByName(meetingName).get(0);   
            if((u.getVisibilityMeeting()).equals(m.getIdMeeting()))
            {
                return true;
            }
              }
           }
        } 
        return false;
    }
    
    
    //========================================================================
    
    public void updateCentroidMeeting( User u, Meeting m,List<Coordonnees> listCo) 
    {
        String msg = "false";
       // List<Coordonnees> listCo = new ArrayList<Coordonnees>();
 
        //listCo = getUsersInMeeting(idMeeting, email, code);
        int cpt = 0;
        float xBar = 0;
        float yBar = 0;
        for (Coordonnees cor : listCo) 
        {
            ++cpt;
            xBar += Float.valueOf(cor.getXCoord());                   
            yBar += Float.valueOf(cor.getYCoord());
        }

        xBar = (Float) xBar/cpt;
        yBar = (Float) yBar/cpt; 

       
        //Réccupération Date
        Date date =  m.getDateMeeting();
        Date now = new Date();
        long diff = Math.abs((date.getTime() - now.getTime()))/60000;

        if(diff > refreshCentroid) {
            float distance = distFrom(xBar, yBar, Float.valueOf(m.getXCoord()), Float.valueOf(m.getYCoord())); 
            if(distance > distMax) 
            {
                //System.out.println("Centroid Updated");
                m.setXCoord(Float.toString(xBar));
                m.setYCoord(Float.toString(yBar));
                m.setDateMeeting(new Date());
                userDao.edit(m);

                msg = "true";
            }                       
        }               
           
    }
    
    public static float distFrom(float lat1, float lng1, float lat2, float lng2) {
        double earthRadius = 3958.75;
        double dLat = Math.toRadians(lat2-lat1);
        double dLng = Math.toRadians(lng2-lng1);
        double a = Math.sin(dLat/2) * Math.sin(dLat/2) +
                   Math.cos(Math.toRadians(lat1)) * Math.cos(Math.toRadians(lat2)) *
                   Math.sin(dLng/2) * Math.sin(dLng/2);
        double c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
        double dist = earthRadius * c;

        int meterConversion = 1609;

        return (float) (dist * meterConversion);
    }
    
    @WebMethod
    public String insertCoordonnee(@WebParam(name="email") String email,            
                                    @WebParam(name="secretCode") String code, 
                                    @WebParam(name="coord_x") String coord_x,
                                    @WebParam(name="coord_y") String coord_y){
       
        
        String msg = "false";
           
        if(!userDao.findUserByMail(email).isEmpty()) {
            if ( coord_x == null ) return msg;
            if ( coord_y == null ) return msg;

            User u = userDao.findUserByMail(email).get(0);
            if(u.getSecretCode().equals(code)){
                Date time = new Date();
                Coordonnees coord;
                if(userDao.findCoordonneesByUser(u.getIdUser()).isEmpty()) {                    
                    coord = new Coordonnees(1,coord_x,coord_y,time,u);
                    userDao.addCoordonnee(coord); 
                } else {   
                    coord = userDao.findCoordonneesByUser(u.getIdUser()).get(0);
                    coord.setTime(time);
                    coord.setXCoord(coord_x);
                    coord.setYCoord(coord_y);
                    userDao.edit(coord);
                }

                msg = "true";
            }
        }
        
        return msg;
         
    }
    
    /*
     @WebMethod
    public List<Coordonnees> affichercoordonnees_user(@WebParam(name="email") String mon_mail,
                                                      @WebParam(name="secretCode") String code){
       
        List<Coordonnees> listcoordonnees = new ArrayList<>();
        if(!userDao.findUserByMail(mon_mail).isEmpty()) { 
           User u = userDao.findUserByMail(mon_mail).get(0);
           if(u.getSecretCode().equals(code)) {
                listcoordonnees = userDao.findCoordonneesByUser(u.getIdUser());
            }
        } 
        return listcoordonnees;
    }*/
    
    @WebMethod
    public List<Coordonnees> getUserFriendsWithCoordoonnee(@WebParam(name="email") String email,
                                                           @WebParam(name="secretCode") String code ) {
        List<Coordonnees> listCo = new ArrayList<>();
        
        if(!userDao.findUserByMail(email).isEmpty()) { 
           User u = userDao.findUserByMail(email).get(0);
           if(u.getSecretCode().equalsIgnoreCase(code)) {
             
               /*
                List<User> listUser = u.getUserList();
                for(User user : listUser) {
                    listcoordonnees = userDao.findCoordonneesByUser(user.getIdUser());
                    listCo.addAll(listcoordonnees);
                } */
               listCo=userDao.coordonnees_amis(u);
           }       
        }
        return listCo;
    }
    
    @WebMethod
     public List<Coordonnees> findAllCoord(){
         return userDao.findAllCoord();     
     }
    
      /**
     * @param email
     * @param nom_meeting
     * @param secretCode
     * @return ****************************************************************************/  
     @WebMethod
     public List<User> getAllFriendMeeting(@WebParam(name="email") String email,
                                         @WebParam(name="nom_meeting") String nom_meeting,
                                         @WebParam(name="secretCode") String secretCode){
         
         
         if(!userDao.findUserByMail(email).isEmpty()) { 
           User u = userDao.findUserByMail(email).get(0);
           if(u.getSecretCode().equals(secretCode)) {
                Meeting m = userDao.findMeetingByName(nom_meeting).get(0);

                List<User> distinctUser = userDao.liste_des_amis_dans_groupe(m, u);
               
                return distinctUser; 
           }       
        }
         
         return null;     
     }

    
    
   public static String message_erreur(int i){
        
       String msg;
       switch(i)
       {
          
           case 0 : msg = "Creation reussie ";
           break;
           
           case 1 : msg = "Veuillez inserer le nom ";
           break;
           
           case 2 : msg = "Probleme de localisation";
           break;
           
           case 3 : msg = "Veuillez choisir un autre nom (nom deja existant)";
           break;
          
           case 4 : msg = "Probleme systeme";
           break;
         
           default: msg = "Probleme systeme";
               
               
       }
       return msg;
    }
    
    @WebMethod
    public int connection(@WebParam(name="email") String mail,
                            @WebParam(name="password") String password,
                            @WebParam(name="code") String code){
        int i = 0;
        if(!userDao.findUserByMail(mail).isEmpty())
        {
        User u = userDao.findUserByMail(mail).get(0);
        if(u.getActivate() == 1 && u.getGeneratedCode().equals(code) && u.getEmail().equals(mail) && u.getPassword().equals(password))
            {
                i = 1;
                u.setConnecter(1);
                userDao.edit(u);
            }
        
        }
        return i;
    }

   
    @WebMethod
    public void deconnecter(@WebParam(name="mail") String mail,
                            @WebParam(name="code") String code){
        
        if(!userDao.findUserByMail(mail).isEmpty())
        {
            User u = userDao.findUserByMail(mail).get(0);
             if(u.getGeneratedCode().equals(code))
            {
            u.setConnecter(0);
            userDao.edit(u);
            }
        }
    }

        //Renvoyer un int au lieu de Boolean. Identifiant pour les erreurs
   public static boolean checkEmail(String email){
        Pattern p = Pattern.compile("^[A-Z0-9._%+-]+@[A-Z0-9.-]+\\.[A-Z]{2,4}$");
        Matcher m = p.matcher(email.toUpperCase());
        return m.matches();
    }
   
   
   public static boolean verifySecretCode(String code) {
       int result = 0;
       if(code!=null) {
           String temp = code.substring(code.length()-3, code.length());
           for(int i=0; i<temp.length();++i) {
                result += Character.getNumericValue(temp.charAt(i));
           }
           return result == 10;
       } else {
           return false;
       }       
   }
   
   /**
    * On met les paramètres : Password + GeneratedCode + SecretCode a null
    * afin de les renvoyer dans le coté client.
    * @param maListe
    * @return 
    */
  
   /****************Groupes***********************************************/
   
     /**
     *
     * @param email
     * @param secretCode
     * @return
     */
        @WebMethod
    public List<Meeting> findMeeting(@WebParam(name="email") String email,
                                     @WebParam(name="secretCode") String secretCode){
        
        List<Meeting> listmeeting = new ArrayList<Meeting>();
        if(!userDao.findUserByMail(email).isEmpty()) { 
           User u = userDao.findUserByMail(email).get(0);
           if(u.getSecretCode().equals(secretCode)) 
           {
                listmeeting= userDao.trouver_mes_rdv(u);
                
           }
        } 
        return listmeeting;
    }
    
    /**
     *
     * @param nomgroupe
     * @param email
     * @param secretCode
     */
    @WebMethod
    public void removeMeeting(@WebParam(name="nomgroupe") String nomgroupe,
                           @WebParam(name="email") String email,
                           @WebParam(name="secretCode") String secretCode){
        if(!userDao.findUserByMail(email).isEmpty()) {
            User u = userDao.findUserByMail(email).get(0);
            if(u.getSecretCode().equals(secretCode)) {
                if(!userDao.findMeetingByName(nomgroupe).isEmpty())
                {
                    Meeting m = userDao.findMeetingByName(nomgroupe).get(0);
                    
                    if((m.getIdUserAdmin().getIdUser()).equals(u.getIdUser()))
                    {
                        userDao.deletemeeting(m);
                    } 
                }
            } 
        }          
    }

    /**
     * @param mon_mail
     * @param code
     * @return
     */
    @WebMethod
    public Coordonnees dernierecoordonnees_user(@WebParam(name="email") String mon_mail,
                                                      @WebParam(name="secretCode") String code){
       
        List<Coordonnees> listcoordonnees = new ArrayList<>();
        if(!userDao.findUserByMail(mon_mail).isEmpty()) { 
           User u = userDao.findUserByMail(mon_mail).get(0);
           if(u.getSecretCode().equals(code)) {
                listcoordonnees = userDao.findCoordonneesUserByTime(u.getIdUser());
            }
        } 
        return listcoordonnees.get(0);
        }
  
    
     @WebMethod
    public void Testaddami(@WebParam(name="email") String email,
                                 @WebParam(name="emailInvite") String emailInvite,
                                 @WebParam(name="secretCode") String code){
      if(!userDao.findUserByMail(email).isEmpty())
        { 
           User u1 = userDao.findUserByMail(email).get(0);
           
           if(u1.getSecretCode().equals(code)) {
                if(emailInvite != null) {
                    
                   if(!userDao.findUserByMail(emailInvite).isEmpty()) {
                    User u2 = userDao.findUserByMail(emailInvite).get(0);          
                    
                    List<User> userlist = new ArrayList<>();
                    userlist.add(u1);
                    u2.setUserList(userlist);
                        
                    List<User> userlist1 = new ArrayList<>();
                    userlist1.add(u2);
                    u1.setUserList(userlist1);
                    
                    userDao.addFriend(u1, u2);
                    }    
                } 
            }
        } 
    } 
   
}
